import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DefaultEventsMap, EventNames, EventParams, EventsMap } from '@socket.io/component-emitter';
import { Socket as _Socket, Manager } from 'socket.io-client';
import { SocketioConfig } from './socketio.interface';
import * as i0 from "@angular/core";
export declare class Socket<ListenEvents extends EventsMap = DefaultEventsMap, EmitEvents extends EventsMap = ListenEvents> implements OnDestroy {
    private socket;
    /**
     * @see {@link Socket.id}
     */
    get id(): string | undefined;
    /**
     * @see {@link Socket.connected}
     */
    get connected(): boolean;
    /**
     * @see {@link Socket.disconnected}
     */
    get disconnected(): boolean;
    /**
     * @see {@link Socket.io}
     */
    get io(): Manager;
    /**
     * @see {@link Socket.auth}
     */
    get auth(): _Socket['auth'];
    /**
     * @see {@link Socket.auth}
     */
    set auth(auth: _Socket['auth']);
    constructor({ url, options }: SocketioConfig);
    ngOnDestroy(): void;
    /**
     * @see {@link Socket.connect}
     */
    connect(): this;
    /**
     * @see {@link Socket.disconnect}
     */
    disconnect(): this;
    /**
     * @see {@link Socket.send}
     */
    send(...args: any[]): this;
    /**
     * @see {@link Socket.emit}
     */
    emit<Ev extends EventNames<EmitEvents>>(eventName: Ev, ...args: EventParams<EmitEvents, Ev>): this;
    /**
     * @see {@link Socket.on}
     */
    on<T>(eventName: string): Observable<T>;
    /**
     * @see {@link Socket.once}
     */
    once<T>(eventName: string): Observable<T>;
    /**
     * @see {@link Socket.compress}
     */
    compress(compress: boolean): this;
    static ɵfac: i0.ɵɵFactoryDeclaration<Socket<any, any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Socket<any, any>>;
}
